

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
	SWEP.HoldType			= "pistol"
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "TF2 Revolver"	
	SWEP.ViewModelFOV		= 61
	SWEP.DrawCrosshair 	= true		
	SWEP.Author				= "Ancient Coffee Bean"
	SWEP.Slot				= 1
	SWEP.SlotPos			= 3
	SWEP.IconLetter			= ""
	
	killicon.AddFont( "weapon_ironsight_pistol", "HL2KillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
end


SWEP.Base				= "weapon_tf2_base"
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_models/v_revolver_spy.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_revolver.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.ForceApply				= 5 -- Amount of force to give to phys objects
SWEP.TracerFreq				= 2 -- Show a tracer on every x bullets 

SWEP.Primary.Sound			= Sound( "Weapons/revolver_shoot.wav" )
SWEP.Primary.Recoil			= 0.0
SWEP.Primary.RecoilXRand	= 0.0
SWEP.Primary.RecoilYRand	= 0.0
SWEP.Primary.Damage			= 13
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone			= 0.01
SWEP.Primary.ClipSize		= 6
SWEP.Primary.Delay			= 0.4
SWEP.Primary.DefaultClip	= 175
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "pistol"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"